unit Inspu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvExControls, JvInspector, JvComponentBase;

type
  TForm1 = class(TForm)
    JvInspector1: TJvInspector;
    JvInspectorBorlandPainter1: TJvInspectorBorlandPainter;
    procedure FormCreate(Sender: TObject);
    procedure JvInspector1AfterItemCreate(Sender: TObject;
      Item: TJvCustomInspectorItem);
  private
   fNulls: String;
   fCharset: String;
   fCollation: String;
   fSize: String;
   fDefault: String;
   procedure GetBoolList(Item: TJvCustomInspectorItem;  Values: TStrings);
   procedure GetCharsetList(Item: TJvCustomInspectorItem;  Values: TStrings);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GetBoolList(Item: TJvCustomInspectorItem;  Values: TStrings);
begin
values.Add('True');
values.Add('False');
end;

procedure TForm1.GetCharsetList(Item: TJvCustomInspectorItem;  Values: TStrings);
begin
Values.CommaText := 'NONE,OCTETS,ASCII,UNICODE_FSS,SJIS_0208,EUCJ_0208,DOS437,ISO8859_1,' +
                    'CYRL,NEXT,WIN1255,KSC_5601,BIG_5,GB_2312';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
JvInspector1.Root.SortKind := iskNone;
JvInspector1.Root.Clear;
TJvInspectorVarData.New(JvInspector1.Root, 'Prohibit nulls', TypeInfo(String), @fNulls);
TJvInspectorVarData.New(JvInspector1.Root, 'Charset', TypeInfo(String), @fCharset);
TJvInspectorVarData.New(JvInspector1.Root, 'Collation', TypeInfo(String), @fCollation);
TJvInspectorVarData.New(JvInspector1.Root, 'Size', TypeInfo(String), @fSize);
TJvInspectorVarData.New(JvInspector1.Root, 'Default value', TypeInfo(String), @fDefault);
end;

procedure TForm1.JvInspector1AfterItemCreate(Sender: TObject;
  Item: TJvCustomInspectorItem);
begin
if (Item.Data.Name = 'Prohibit nulls') then
 begin    
  Item.Flags := Item.Flags + [iifAllowNonListValues];
  Item.OnGetValueList := GetBoolList;  
 end;
if (Item.Data.Name = 'Charset') then
 begin
  Item.Flags := Item.Flags + [iifAllowNonListValues];
  Item.OnGetValueList := GetCharsetList;
 end;

end;

end.
